//<c>   Copyright 1991-2000 by Gerry J. Danen; all rights reserved.

//<t>   Set printer to HP PCL landscape mode

#include"gd_tools.h"


void    main( int argc, char *argv[] )
{
    UCHAR       outfl1[]="c:\\hppcl.$$1", outfl2[]="c:\\hppcl.$$2",
                inFile[FS_LEN]="", destFile[FS_LEN]="PRN",
                fontName[41]="LGothic", fontSize[41]="14", cmd[128] ;
    FILE        *outfh ;

    if ( argc > 1 )
        ST_CPY( inFile, argv[1] );
    strupr( inFile );
    if ( argc > 2 )
        ST_CPY( destFile, argv[2] );
    strupr( destFile );

    if ( ! strlen(inFile) )
    {
        fprintf( stderr, "Please supply a file name to be printed.\a\n" );
        exit( GD_ERROR_FILE_NOT_FOUND );
    }

    if ( ! fl_exist( inFile ) )
    {
        fprintf( stderr, "File %s not found.\a\n" );
        exit( GD_ERROR_FILE_NOT_FOUND );
    }

//  parameters:
//      /font=xxx
//      /size=xxx
//      /out=outfile
//      /header - print file header on page 1

    outfh = fopen( outfl1, "wb" );              // header
    if ( ! outfh )
    {
        fprintf( stderr, "Could not open temporary file %s\a\n", outfl1 );
        exit( GD_ERROR_CANNOT_OPEN_FOR_WRITE );
    }
    fprintf( outfh, "%s%s", hp_landscape(), hp_font(fontName,fontSize,FALSE,FALSE) );
//  fprintf( outfh, "%s%s", hp_landscape(), hp_font("LGothic", "14", FALSE, FALSE) );
//  fprintf( outfh, "%s%s%s", hp_landscape(), hp_font(argv[2], argv[3], TRUE, FALSE), hp_lpi(8) );
//  fprintf( outfh, "%s%s%s%s%s",
//                  hp_landscape(),
//                  "\x1B(s16.67h8.5v0T",
//                  hp_font("lpr", "14", FALSE, FALSE),
//                  "\x1B&k8H",
//                  hp_lpi(8) );

    fclose ( outfh );

    outfh = fopen( outfl2, "wb" );              // trailer
    if ( ! outfh )
    {
        fprintf( stderr, "Could not open temporary file %s\a\n", outfl2 );
        exit( GD_ERROR_CANNOT_OPEN_FOR_WRITE );
    }
    fprintf( outfh, "%s%s%s", hp_eject(), hp_portrait(), hp_reset() );
    fclose ( outfh );

    printf( "Printing file %s to %s\n", inFile, destFile );

    sprintf( cmd, "copy /b %s+%s+%s %s >nul", outfl1, inFile, outfl2, destFile );
    system ( cmd );

    fl_delete( outfl1 );
    fl_delete( outfl2 );

    exit( 0 );
}
